// Expose Internal DOM library
var $$ = Dom7;

// Initialize your app
var myApp = new Framework7({
    // Enable Material theme
    init: false,
    modalTitle: 'Wallpaper',
    material: true,
    swipePanel: 'right',
    pushState: false,
    hideNavbarOnPageScroll: true,
    hideToolbarOnPageScroll: true,
    tapHold: true,
    domCache: false,
    onPageBeforeInit: function (page) {
        var skip = $.jStorage.get('tutorial');
        var array = checkAndMergeArray();
        $$('head').append('<style>.navbar,.searchbar, .subnavbar, .toolbar{ background: ' + Settings.themeColors.colorPrimary + '}</style>');

        if (!Array.isArray(array)) {
            $$('.views').css({backgroundColor: Settings.themeColors.colorPrimary}).html('<h2 class="not-favorite" style="color: white;font-size: 2em;">' + array + '</h2>').find('div').remove();
        } else {
            if (skip == null) {
                $$('.welcomescreen-container ').remove();
                var welcomescreen_slides = [{id: 'slide0', picture: '<div class="tutorialicon"><div class="delete-toturial-block" style="width: 70%;margin: 0 auto;"><img style="width: 110px;" src="' + Settings.icon + '"></div></div>', text: 'Welcome! This tutorial will help you discover all features of this app. You can skip this tutorial by tapping \'Skip\' button in the corner. This tutorial will be shown only once.'}, {id: 'slide1', picture: '<div class="tutorialicon"><div class="delete-toturial-block" style="width: 70%;margin: 0 auto;"><i class="material-icons" style="font-size: 10em;">&#xE16C;</i></div></div>', text: 'You can delete categories by swiping left or tapping \'Delete\' button after a short left swipe.'}, {id: 'slide2', picture: '<div class="tutorialicon"><div class="delete-toturial-block" style="width: 70%;margin: 0 auto;"><i class="material-icons" style="font-size: 10em;">&#xE8B6;</i></div></div>', text: 'You can search images by typing your query in search field and selecting category'}, {id: 'slide3', picture: '<div class="tutorialicon"><div class="delete-toturial-block" style="width: 70%;margin: 0 auto;"><i class="material-icons" style="font-size: 10em;">&#xE3F4;</i></div></div>', text: 'You can set image as a device wallpaper by tapping \'Set as wallpaper\' button'}, {id: 'slide4', picture: '<div class="tutorialicon"><div class="delete-toturial-block" style="width: 70%;margin: 0 auto;"><i class="material-icons" style="font-size: 10em;">&#xE838;</i></div></div>', text: 'You can add an image to Favourites and see it in Favourites category'}, {id: 'slide5', picture: '<div class="tutorialicon"><div class="delete-toturial-block" style="width: 70%;margin: 0 auto;"><i class="material-icons" style="font-size: 10em;">&#xE8FF;</i></div></div>', text: 'Double-tap image to zoom in or zoom out'}, {id: 'slide6', picture: '<div class="tutorialicon"><div class="delete-toturial-block" style="width: 70%;margin: 0 auto;"><i class="material-icons" style="font-size: 10em;">&#xE813;</i></div></div>', text: 'Thanks for reading! Enjoy this app.<br> <a class="welcomescreen-closebtn close-welcomescreen button" style="color: white; font-size: 1.1em; margin: 10px 0 10px 0; font-weight: 500; position: relative; text-align: center; padding: 0;" href="#">End Tutorial</a>'}];
                var options = {'bgcolor': Settings.themeColors.colorPrimary, 'fontcolor': '#fff'};
                var welcomescreen = myApp.welcomescreen(welcomescreen_slides, options);
                $.jStorage.set('tutorial', 'true');
            }
            $$(document).on('click', '.welcomescreen-closebtn', function () {
                $$('.panel').removeClass('active').css({display: 'none'});
                $$('.panel-overlay').css({display: 'none'});
            });
        }
    },
    onPageAfterBack: function(page){
        if(page.views[0].url.indexOf('photo')+1){
            var hash = page.views[0].url.substring(20);
            var category = getCategoryAlbum(hash);
            var type = getTypeAlbum(hash);
            loadCategory(category, type, hash);
        } else {
            if(page.views[0].url.indexOf('index')+1){
                $$('.search-list ul li').remove();
                $$('.search-list').attr('class','search-list disabled');
                initMain();
            }
        }
    }
});

// Add main view
var mainView = myApp.addView('.view-main', {});

// Callbacks to run specific code for specific pages, for example for About page:
myApp.onPageInit('photo', function (page) {
    var hash = page.url.substring(20);
    var category = getCategoryAlbum(hash);
    var type = getTypeAlbum(hash);
    $$('.search-list ul li').remove();
    $$('.search-list').attr('class','search-list disabled');
    $$('.search-input').val('');
    loadCategory(category, type, hash);
});

// Callbacks to run specific code for specific pages, for example for About page:
myApp.onPageInit('favorite', function (page) {
    loadFavorite();
});

// Callbacks to run specific code for specific pages, for example for About page:
myApp.onPageInit('settings', function (page) {
    loadSettings();
});
// Callbacks to run specific code for specific pages, for example for About page:
myApp.onPageInit('index', function (page) {
    initMain();
});

function initMain(){
    var panel = $$('.panel');
    var panel_template = Template7.compile(panel[0].outerHTML);

    var json = initMainAlbums();
    var albums = checkAndMergeArray();

    var today = new Date();
    var current_time = new Date(today.getFullYear(), today.getMonth() + 1, today.getDate()).getTime();

    var past_time = getPastTime();
    var checkDate = checkDateTimestamp(current_time, past_time);

    panel.html($$(panel_template({topic: albums[1]}))[0].innerHTML);

    if (checkDate) setCategoryLocalStorage(albums);
    if (json) {

        $$('.name_category_album').html(Settings.name);
        $$('.main-photo').find('li').remove();
        window.photoBrowserStandalone = myApp.photoBrowser({
            photos: json[1],
            lazyLoading: true,
            lazyLoadingInPrevNext: true,
            lazyLoadingOnTransitionStart: true,
            theme: 'dark'
        });
        $$.each(json[1], function (i, v) {
            $$('.main-photo').append('' +
                '<li class="item-content"><div class="item-media open-img" data-id="' + i + '"><img data-id="' + i + '" src="' + v.thm_url + '"></div></li>' +
                '');
        });
        $$('.open-img').on('click', function () {
            var id = $$(this).data('id');
            photoBrowserStandalone.open(id);
        });
    } else {
        var element = $.jStorage.get(Settings.categoryApiAlbum[0].topic + '_api');
        if (element) {
            var array = JSON.parse(element);
            var photo = [];
            $$('.name_category_album').html(Settings.name);
            $$('.list-images').addClass('main-category-' + Settings.categoryApiAlbum[0].topic);
            $$.each(array, function (i, v) {
                photo.push({index: i, url: v.path_url, thm_url: v.thm_url, caption: v.tags});
            });

            window.photoBrowserStandalone = myApp.photoBrowser({
                photos: photo,
                lazyLoading: true,
                lazyLoadingInPrevNext: true,
                lazyLoadingOnTransitionStart: true,
                theme: 'dark'
            });
            $$.each(photo, function (i, v) {
                $$('.list-block.virtual-list.main-category-' + Settings.categoryApiAlbum[0].topic).append('' +
                    '<li class="item-content"><div class="item-media open-img" data-id="' + v.index + '"><img data-id="' + v.index + '" src="' + v.thm_url + '"></div></li>' +
                    '');
            });

            $$('.open-img').on('click', function () {
                var id = $$(this).data('id');
                photoBrowserStandalone.open(id);
            });
        } else {
            var key = keyPixabay[Math.floor(Math.random() * keyPixabay.length)];
            $$.ajax({
                url: 'https://pixabay.com/api/?key=' + key + '&q=' + Settings.categoryApiAlbum[0].topic + '&image_type=photo&per_page=200',
                statusCode: {
                    429: function (xhr) {
                        console.log(xhr);
                    },
                    200: function (data) {
                        initAjaxElement(JSON.parse(data.response).hits);

                        var arrayElement = [];
                        $$.each(JSON.parse(data.response).hits, function (i, v) {
                            var thm_url = v.previewURL;
                            var path_url = v.webformatURL;
                            var tags = v.tags;
                            arrayElement.push({previewURL: thm_url, webformatURL: path_url, tags: tags});
                        });
                        $.jStorage.set(Settings.categoryApiAlbum[0].topic + '_api', JSON.stringify(arrayElement));
                    }
                }
            })
        }
    }

    $$('.open-search').on('click', function () {
        $$('.searchbar').removeClass('disabled-search');
    });

    $$(document).on('click', function (e) {
        if (!$$(e.srcElement).hasClass('open-search') && !$$(e.srcElement).hasClass('icon-search') && !$$(e.srcElement).hasClass('searchbar-input') && !$$(e.srcElement).hasClass('search-input') && !$$(e.srcElement).hasClass('searchbar-clear')) {
            if (!$$('.searchbar').hasClass('disabled-search')) $$('.searchbar').addClass('disabled-search');
        }
    });

    $$('.search-input').on('keyup keydown blur', function (e) {
        var val = $$(this).val();
        if (val !== '') {
            $$.getJSON("http://suggestqueries.google.com/complete/search?callback=?", {
                "hl": "en",
                "ds": "yt",
                "jsonp": "suggestCallBack",
                "q": val,
                "client": "youtube"
            });
            suggestCallBack = function (data) {
                $$('.search-list ul li').remove();
                $$.each(data[1], function (key, val) {
                    var category = val[0].replace(/\s/ig, '-');
                    $$('.search-list').removeClass('disabled').find('ul').append('<li><a class="link button ripple-blue" href="photo.html#category=' + category + '_api">' + val[0] + '</a></li>');
                });

            };
        } else {
            $$('.search-list ul li').remove();
            $$('.search-list').attr('class','search-list disabled');
        }
    });
}
$$('.search-list ul li').on('click', function () {
    $$('.search-list ul li').remove();
    $$('.search-list').attr('class','search-list disabled');
});
function initAjaxElement(data){
    var array = data;
    var arrayElement = [];
    $$.each(array, function (i, v) {
        var thm_url = v.previewURL;
        var path_url = v.webformatURL;
        var tags = v.tags;
        arrayElement.push({thm_url: thm_url, path_url: path_url, tags: tags});
    });

    var photo = [];
    $$('.name_category_album').html(Settings.name);
    $$('.list-images').addClass('main-category-' + Settings.categoryApiAlbum[0].topic);
    $$.each(arrayElement, function (i, v) {
        photo.push({index: i, url: v.path_url, thm_url: v.thm_url, caption: v.tags});
    });

    window.photoBrowserStandalone = myApp.photoBrowser({
        photos: photo,
        lazyLoading: true,
        lazyLoadingInPrevNext: true,
        lazyLoadingOnTransitionStart: true,
        theme: 'dark'
    });
    $$.each(photo, function (i, v) {
        $$('.list-block.virtual-list.main-category-' + Settings.categoryApiAlbum[0].topic).append('' +
            '<li class="item-content"><div class="item-media open-img" data-id="' + v.index + '"><img data-id="' + v.index + '" src="' + v.thm_url + '"></div></li>' +
            '');
    });

    $$('.open-img').on('click', function () {
        var id = $$(this).data('id');
        photoBrowserStandalone.open(id);
    });
}
myApp.init();